Loading...
Searching...
No Matches
itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType > Class Template Reference
Components » Metrics

`#include <itkTransformRigidityPenaltyTerm.h>`

## Detailed Description

template<class TFixedImage, class TScalarType>
class itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >

A cost function that calculates a rigidity penalty term.

A cost function that calculates a rigidity penalty term based on the B-spline coefficients of a B-spline transformation. This penalty term is a function of the 1st and 2nd order spatial derivatives of a transformation.

The intended use for this metric is to filter a B-spline coefficient image in order to calculate a rigidity penalty term on a B-spline transform.

The RigidityPenaltyTermValueImageFilter at each pixel location is computed by convolution with some separable 1D kernels.

The rigid penalty term penalizes deviations from a rigid transformation at regions specified by the so-called rigidity images.

This metric only works with B-splines as a transformation model.

References:
[1] M. Staring, S. Klein and J.P.W. Pluim, "A Rigidity Penalty Term for Nonrigid Registration," Medical Physics, vol. 34, no. 11, pp. 4098 - 4108, November 2007.

See also
  BSplineTransform

Definition at line 71 of file itkTransformRigidityPenaltyTerm.h.

Inheritance diagram for itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >:
[legend]

## Public Types

using | BSplineTransformPointer = typename BSplineTransformType::Pointer
using | BSplineTransformType = BSplineOrder3TransformType
using | CoefficientImageIteratorType = ImageRegionIterator<CoefficientImageType>
using | CoefficientImagePointer = typename CoefficientImageType::Pointer
using | CoefficientImageSpacingType = typename CoefficientImageType::SpacingType
using | CoefficientImageType = typename BSplineTransformType::ImageType
using | ConstPointer = SmartPointer<const Self>
using | DilateFilterPointer = typename DilateFilterType::Pointer
using | DilateFilterType = GrayscaleDilateImageFilter<RigidityImageType, RigidityImageType, StructuringElementType>
using | GridSpacingType = typename BSplineTransformType::SpacingType
using | NeighborhoodIteratorType = NeighborhoodIterator<CoefficientImageType>
using | NeighborhoodSizeType = typename NeighborhoodType::SizeType
using | NeighborhoodType = Neighborhood<ScalarType, Self::FixedImageDimension>
using | NOIFType = NeighborhoodOperatorImageFilter<CoefficientImageType, CoefficientImageType>
using | Pointer = SmartPointer<Self>
using | RadiusType = typename NeighborhoodIteratorType::RadiusType
using | RigidityImageIndexType = typename RigidityImageType::IndexType
using | RigidityImageIteratorType = ImageRegionIterator<RigidityImageType>
using | RigidityImagePointer = typename RigidityImageType::Pointer
using | RigidityImagePointType = typename RigidityImageType::PointType
using | RigidityImageRegionType = typename RigidityImageType::RegionType
using | RigidityImageType = CoefficientImageType
using | RigidityPixelType = typename RigidityImageType::PixelType
using | Self = TransformRigidityPenaltyTerm
using | SERadiusType = typename StructuringElementType::RadiusType
using | StructuringElementType = BinaryBallStructuringElement<RigidityPixelType, Self::FixedImageDimension>
using | Superclass = TransformPenaltyTerm<TFixedImage, TScalarType>
Public Types inherited from itk::TransformPenaltyTerm< TFixedImage, TScalarType >
using | ConstPointer
using | InternalMatrixType
using | JacobianOfSpatialHessianType
using | JacobianOfSpatialJacobianType
using | Pointer
using | ScalarType
using | Self
using | SpatialHessianType
using | SpatialJacobianType
using | Superclass
using | TransformType
Public Types inherited from itk::AdvancedImageToImageMetric< TFixedImage, TFixedImage >
using | AdvancedTransformType
using | BSplineOrder1TransformPointer
using | BSplineOrder1TransformType
using | BSplineOrder2TransformPointer
using | BSplineOrder2TransformType
using | BSplineOrder3TransformPointer
using | BSplineOrder3TransformType
using | CombinationTransformType
using | ConstPointer
using | DerivativeValueType
using | FixedImageLimiterOutputType
using | FixedImageLimiterPointer
using | FixedImageLimiterType
using | FixedImageMaskConstPointer
using | FixedImageMaskPointer
using | FixedImageMaskType
using | FixedImagePixelType
using | FixedImagePointer
using | ImageSampleContainerPointer
using | ImageSampleContainerType
using | ImageSamplerPointer
using | ImageSamplerType
using | MovingImageDerivativeScalesType
using | MovingImageLimiterOutputType
using | MovingImageLimiterPointer
using | MovingImageLimiterType
using | MovingImageMaskConstPointer
using | MovingImageMaskPointer
using | MovingImageMaskType
using | MovingImagePointer
using | MovingImageRegionType
using | NumberOfParametersType
using | Pointer
using | ScalarType
using | Self
using | Superclass
using | ThreadInfoType

## Public Member Functions

void | BeforeThreadedGetValueAndDerivative (const TransformParametersType &parameters) const override
void | CheckUseAndCalculationBooleans ()
void | FillRigidityCoefficientImage (const ParametersType &parameters) const
virtual const char * | GetClassName () const
void | GetDerivative (const ParametersType &parameters, DerivativeType &derivative) const override
virtual const MeasureType & | GetLinearityConditionGradientMagnitude ()
virtual const MeasureType & | GetLinearityConditionValue ()
virtual ScalarType | GetLinearityConditionWeight () const
virtual const MeasureType & | GetOrthonormalityConditionGradientMagnitude ()
virtual const MeasureType & | GetOrthonormalityConditionValue ()
virtual ScalarType | GetOrthonormalityConditionWeight () const
virtual const MeasureType & | GetPropernessConditionGradientMagnitude ()
virtual const MeasureType & | GetPropernessConditionValue ()
virtual ScalarType | GetPropernessConditionWeight () const
MeasureType | GetValue (const ParametersType &parameters) const override
void | GetValueAndDerivative (const ParametersType &parameters, MeasureType &value, DerivativeType &derivative) const override
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (TransformRigidityPenaltyTerm)
| itkStaticConstMacro (FixedImageDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (ImageDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, FixedImageType::ImageDimension)
virtual void | SetBSplineTransform (BSplineTransformType *_arg)
virtual void | SetCalculateLinearityCondition (bool _arg)
virtual void | SetCalculateOrthonormalityCondition (bool _arg)
virtual void | SetCalculatePropernessCondition (bool _arg)
virtual void | SetDilateRigidityImages (bool _arg)
virtual void | SetDilationRadiusMultiplier (CoordinateRepresentationType _arg)
virtual void | SetFixedRigidityImage (RigidityImageType *_arg)
virtual void | SetLinearityConditionWeight (ScalarType _arg)
virtual void | SetMovingRigidityImage (RigidityImageType *_arg)
virtual void | SetOrthonormalityConditionWeight (ScalarType _arg)
virtual void | SetPropernessConditionWeight (ScalarType _arg)
virtual void | SetUseFixedRigidityImage (bool _arg)
virtual void | SetUseLinearityCondition (bool _arg)
virtual void | SetUseMovingRigidityImage (bool _arg)
virtual void | SetUseOrthonormalityCondition (bool _arg)
virtual void | SetUsePropernessCondition (bool _arg)
Public Member Functions inherited from itk::TransformPenaltyTerm< TFixedImage, TScalarType >
| ITK_DISALLOW_COPY_AND_MOVE (TransformPenaltyTerm)
| itkStaticConstMacro (FixedImageDimension, unsigned int, FixedImageType::ImageDimension)
Public Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TFixedImage >
virtual const FixedImageLimiterType * | GetFixedImageLimiter ()
const FixedImageMaskType * | GetFixedImageMask () const override
virtual double | GetFixedLimitRangeRatio () const
ImageSamplerType * | GetImageSampler () const
virtual const MovingImageDerivativeScalesType & | GetMovingImageDerivativeScales ()
virtual const MovingImageLimiterType * | GetMovingImageLimiter ()
const MovingImageMaskType * | GetMovingImageMask () const override
virtual double | GetMovingLimitRangeRatio () const
virtual double | GetRequiredRatioOfValidSamples () const
virtual bool | GetScaleGradientWithRespectToMovingImageOrientation () const
const AdvancedTransformType * | GetTransform () const override
AdvancedTransformType * | GetTransform () override
virtual bool | GetUseFixedImageLimiter () const
virtual bool | GetUseImageSampler () const
virtual const bool & | GetUseMetricSingleThreaded ()
virtual bool | GetUseMovingImageDerivativeScales () const
virtual bool | GetUseMovingImageLimiter () const
virtual const bool & | GetUseMultiThread ()
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedImageToImageMetric)
| itkStaticConstMacro (FixedImageDimension, unsigned int, TFixedImage::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, TFixedImage::ImageDimension)
virtual void | SetFixedImageLimiter (FixedImageLimiterType *_arg)
virtual void | SetFixedImageMask (const FixedImageMaskType *const arg)
virtual void | SetFixedLimitRangeRatio (double _arg)
virtual void | SetImageSampler (ImageSamplerType *_arg)
virtual void | SetMovingImageDerivativeScales (MovingImageDerivativeScalesType _arg)
virtual void | SetMovingImageLimiter (MovingImageLimiterType *_arg)
virtual void | SetMovingImageMask (const MovingImageMaskType *const arg)
virtual void | SetMovingLimitRangeRatio (double _arg)
virtual void | SetRequiredRatioOfValidSamples (double _arg)
virtual void | SetScaleGradientWithRespectToMovingImageOrientation (bool _arg)
virtual void | SetTransform (AdvancedTransformType *arg)
virtual void | SetUseMetricSingleThreaded (bool _arg)
virtual void | SetUseMovingImageDerivativeScales (bool _arg)
virtual void | SetUseMultiThread (bool _arg)
virtual void | UseMetricSingleThreadedOff ()
virtual void | UseMetricSingleThreadedOn ()
virtual void | UseMultiThreadOff ()
virtual void | UseMultiThreadOn ()

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

void | PrintSelf (std::ostream &os, Indent indent) const override
| TransformRigidityPenaltyTerm ()
| ~TransformRigidityPenaltyTerm () override=default
Protected Member Functions inherited from itk::TransformPenaltyTerm< TFixedImage, TScalarType >
virtual bool | CheckForBSplineTransform2 (BSplineOrder3TransformPointer &bspline) const
| TransformPenaltyTerm ()=default
| ~TransformPenaltyTerm () override=default
Protected Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TFixedImage >
| AdvancedImageToImageMetric ()
virtual void | AfterThreadedGetValue (MeasureType &) const
virtual void | AfterThreadedGetValueAndDerivative (MeasureType &, DerivativeType &) const
void | CheckForAdvancedTransform ()
void | CheckForBSplineInterpolator ()
void | CheckForBSplineTransform () const
void | CheckNumberOfSamples (unsigned long wanted, unsigned long found) const
virtual bool | EvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient) const
bool | EvaluateTransformJacobian (const FixedImagePointType &fixedImagePoint, TransformJacobianType &jacobian, NonZeroJacobianIndicesType &nzji) const
virtual void | EvaluateTransformJacobianInnerProduct (const TransformJacobianType &jacobian, const MovingImageDerivativeType &movingImageDerivative, DerivativeType &imageJacobian) const
bool | FastEvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient, const ThreadIdType threadId) const
virtual void | InitializeImageSampler ()
void | InitializeLimiters ()
virtual void | InitializeThreadingParameters () const
virtual bool | IsInsideMovingMask (const MovingImagePointType &point) const
| itkAlignedTypedef (ITK_CACHE_LINE_ALIGNMENT, PaddedGetValueAndDerivativePerThreadStruct, AlignedGetValueAndDerivativePerThreadStruct)
| itkPadStruct (ITK_CACHE_LINE_ALIGNMENT, GetValueAndDerivativePerThreadStruct, PaddedGetValueAndDerivativePerThreadStruct)
void | LaunchGetValueAndDerivativeThreaderCallback () const
void | LaunchGetValueThreaderCallback () const
void | PrintSelf (std::ostream &os, Indent indent) const override
void | SetFixedImageMask (const typename Superclass::FixedImageMaskType *) final
void | SetFixedImageMask (typename Superclass::FixedImageMaskType *) final
void | SetMovingImageMask (const typename Superclass::MovingImageMaskType *) final
void | SetMovingImageMask (typename Superclass::MovingImageMaskType *) final
virtual void | SetUseFixedImageLimiter (bool _arg)
virtual void | SetUseImageSampler (bool _arg)
virtual void | SetUseMovingImageLimiter (bool _arg)
virtual void | ThreadedGetValue (ThreadIdType) const
virtual void | ThreadedGetValueAndDerivative (ThreadIdType) const
MovingImagePointType | TransformPoint (const FixedImagePointType &fixedImagePoint) const
| ~AdvancedImageToImageMetric () override=default

## Private Member Functions

void | Create1DOperator (NeighborhoodType &F, const std::string &whichF, const unsigned int WhichDimension, const CoefficientImageSpacingType &spacing) const
void | CreateNDOperator (NeighborhoodType &F, const std::string &whichF, const CoefficientImageSpacingType &spacing) const
virtual void | DilateRigidityImages ()
CoefficientImagePointer | FilterSeparable (const CoefficientImageType *, const std::vector< NeighborhoodType > &Operators) const

## Private Attributes

BSplineTransformPointer | m_BSplineTransform {}
bool | m_CalculateLinearityCondition {}
bool | m_CalculateOrthonormalityCondition {}
bool | m_CalculatePropernessCondition {}
bool | m_DilateRigidityImages {}
CoordinateRepresentationType | m_DilationRadiusMultiplier {}
RigidityImagePointer | m_FixedRigidityImage {}
RigidityImagePointer | m_FixedRigidityImageDilated {}
std::vector< DilateFilterPointer > | m_FixedRigidityImageDilation {}
MeasureType | m_LinearityConditionGradientMagnitude {}
MeasureType | m_LinearityConditionValue {}
ScalarType | m_LinearityConditionWeight {}
RigidityImagePointer | m_MovingRigidityImage {}
RigidityImagePointer | m_MovingRigidityImageDilated {}
std::vector< DilateFilterPointer > | m_MovingRigidityImageDilation {}
MeasureType | m_OrthonormalityConditionGradientMagnitude {}
MeasureType | m_OrthonormalityConditionValue {}
ScalarType | m_OrthonormalityConditionWeight {}
MeasureType | m_PropernessConditionGradientMagnitude {}
MeasureType | m_PropernessConditionValue {}
ScalarType | m_PropernessConditionWeight {}
RigidityImagePointer | m_RigidityCoefficientImage {}
bool | m_RigidityCoefficientImageIsFilled {}
MeasureType | m_RigidityPenaltyTermValue {}
bool | m_UseFixedRigidityImage {}
bool | m_UseLinearityCondition {}
bool | m_UseMovingRigidityImage {}
bool | m_UseOrthonormalityCondition {}
bool | m_UsePropernessCondition {}

## Additional Inherited Members

Protected Types inherited from itk::AdvancedImageToImageMetric< TFixedImage, TFixedImage >
using | BSplineInterpolatorFloatPointer
using | BSplineInterpolatorFloatType
using | BSplineInterpolatorPointer
using | BSplineInterpolatorType
using | FixedImageIndexType
using | FixedImageIndexValueType
using | FixedImagePointType
using | LinearInterpolatorPointer
using | LinearInterpolatorType
using | MovingImageContinuousIndexType
using | MovingImageDerivativeType
using | MovingImageIndexType
using | MovingImagePointType
using | NonZeroJacobianIndicesType
using | ReducedBSplineInterpolatorPointer
using | ReducedBSplineInterpolatorType
Static Protected Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TFixedImage >
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | AccumulateDerivativesThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueAndDerivativeThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueThreaderCallback (void *arg)
Protected Attributes inherited from itk::AdvancedImageToImageMetric< TFixedImage, TFixedImage >
AdvancedTransformType::Pointer | m_AdvancedTransform
FixedImageLimiterOutputType | m_FixedImageMaxLimit
FixedImageLimiterOutputType | m_FixedImageMinLimit
FixedImagePixelType | m_FixedImageTrueMax
FixedImagePixelType | m_FixedImageTrueMin
double | m_FixedLimitRangeRatio
std::unique_ptr< AlignedGetValueAndDerivativePerThreadStruct[]> | m_GetValueAndDerivativePerThreadVariables
ThreadIdType | m_GetValueAndDerivativePerThreadVariablesSize
ImageSamplerPointer | m_ImageSampler
MovingImageLimiterOutputType | m_MovingImageMaxLimit
MovingImageLimiterOutputType | m_MovingImageMinLimit
MovingImagePixelType | m_MovingImageTrueMax
MovingImagePixelType | m_MovingImageTrueMin
double | m_MovingLimitRangeRatio
MultiThreaderParameterType | m_ThreaderMetricParameters
bool | m_TransformIsBSpline
bool | m_UseMetricSingleThreaded
bool | m_UseMultiThread

## Member Typedef Documentation

## BSplineTransformPointer

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::BSplineTransformPointer = typename BSplineTransformType::Pointer

Definition at line 150 of file itkTransformRigidityPenaltyTerm.h.

## BSplineTransformType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::BSplineTransformType = BSplineOrder3TransformType

Typedef's for B-spline transform.

Definition at line 149 of file itkTransformRigidityPenaltyTerm.h.

## CoefficientImageIteratorType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::CoefficientImageIteratorType = ImageRegionIterator<CoefficientImageType>

Definition at line 159 of file itkTransformRigidityPenaltyTerm.h.

## CoefficientImagePointer

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::CoefficientImagePointer = typename CoefficientImageType::Pointer

Definition at line 153 of file itkTransformRigidityPenaltyTerm.h.

## CoefficientImageSpacingType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::CoefficientImageSpacingType = typename CoefficientImageType::SpacingType

Definition at line 154 of file itkTransformRigidityPenaltyTerm.h.

## CoefficientImageType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::CoefficientImageType = typename BSplineTransformType::ImageType

Definition at line 152 of file itkTransformRigidityPenaltyTerm.h.

## ConstPointer

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::ConstPointer = SmartPointer<const Self>

Definition at line 80 of file itkTransformRigidityPenaltyTerm.h.

## DilateFilterPointer

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::DilateFilterPointer = typename DilateFilterType::Pointer

Definition at line 175 of file itkTransformRigidityPenaltyTerm.h.

## DilateFilterType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::DilateFilterType = GrayscaleDilateImageFilter<RigidityImageType, RigidityImageType, StructuringElementType>

Definition at line 174 of file itkTransformRigidityPenaltyTerm.h.

## GridSpacingType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GridSpacingType = typename BSplineTransformType::SpacingType

Definition at line 151 of file itkTransformRigidityPenaltyTerm.h.

## NeighborhoodIteratorType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::NeighborhoodIteratorType = NeighborhoodIterator<CoefficientImageType>

Definition at line 161 of file itkTransformRigidityPenaltyTerm.h.

## NeighborhoodSizeType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::NeighborhoodSizeType = typename NeighborhoodType::SizeType

Definition at line 158 of file itkTransformRigidityPenaltyTerm.h.

## NeighborhoodType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::NeighborhoodType = Neighborhood<ScalarType, Self::FixedImageDimension>

Typedef support for neighborhoods, filters, etc.

Definition at line 157 of file itkTransformRigidityPenaltyTerm.h.

## NOIFType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::NOIFType = NeighborhoodOperatorImageFilter<CoefficientImageType, CoefficientImageType>

Definition at line 160 of file itkTransformRigidityPenaltyTerm.h.

## Pointer

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::Pointer = SmartPointer<Self>

Definition at line 79 of file itkTransformRigidityPenaltyTerm.h.

## RadiusType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RadiusType = typename NeighborhoodIteratorType::RadiusType

Definition at line 162 of file itkTransformRigidityPenaltyTerm.h.

## RigidityImageIndexType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RigidityImageIndexType = typename RigidityImageType::IndexType

Definition at line 169 of file itkTransformRigidityPenaltyTerm.h.

## RigidityImageIteratorType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RigidityImageIteratorType = ImageRegionIterator<RigidityImageType>

Definition at line 171 of file itkTransformRigidityPenaltyTerm.h.

## RigidityImagePointer

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RigidityImagePointer = typename RigidityImageType::Pointer

Definition at line 166 of file itkTransformRigidityPenaltyTerm.h.

## RigidityImagePointType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RigidityImagePointType = typename RigidityImageType::PointType

Definition at line 170 of file itkTransformRigidityPenaltyTerm.h.

## RigidityImageRegionType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RigidityImageRegionType = typename RigidityImageType::RegionType

Definition at line 168 of file itkTransformRigidityPenaltyTerm.h.

## RigidityImageType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RigidityImageType = CoefficientImageType

Typedef's for the construction of the rigidity image.

Definition at line 165 of file itkTransformRigidityPenaltyTerm.h.

## RigidityPixelType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::RigidityPixelType = typename RigidityImageType::PixelType

Definition at line 167 of file itkTransformRigidityPenaltyTerm.h.

## Self

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::Self = TransformRigidityPenaltyTerm

Standard itk stuff.

Definition at line 77 of file itkTransformRigidityPenaltyTerm.h.

## SERadiusType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SERadiusType = typename StructuringElementType::RadiusType

Definition at line 173 of file itkTransformRigidityPenaltyTerm.h.

## StructuringElementType

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::StructuringElementType = BinaryBallStructuringElement<RigidityPixelType, Self::FixedImageDimension>

Definition at line 172 of file itkTransformRigidityPenaltyTerm.h.

## Superclass

template<class TFixedImage, class TScalarType>

using itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::Superclass = TransformPenaltyTerm<TFixedImage, TScalarType>

Definition at line 78 of file itkTransformRigidityPenaltyTerm.h.

## Constructor & Destructor Documentation

## TransformRigidityPenaltyTerm()

template<class TFixedImage, class TScalarType>

itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::TransformRigidityPenaltyTerm | ( |  | ) |

protected

The constructor.

## ~TransformRigidityPenaltyTerm()

template<class TFixedImage, class TScalarType>

itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::~TransformRigidityPenaltyTerm | ( |  | ) |

override protected default

The destructor.

## Member Function Documentation

## BeforeThreadedGetValueAndDerivative()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::BeforeThreadedGetValueAndDerivative | ( | const TransformParametersType & | parameters | ) | const

override virtual

Contains calls from GetValueAndDerivative that are thread-unsafe.

Reimplemented from itk::AdvancedImageToImageMetric< TFixedImage, TFixedImage >.

## CheckUseAndCalculationBooleans()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::CheckUseAndCalculationBooleans | ( |  | ) |

Check stuff.

## Create1DOperator()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::Create1DOperator | ( | NeighborhoodType & | F,
|  | const std::string & | whichF,
|  | const unsigned int | WhichDimension,
|  | const CoefficientImageSpacingType & | spacing ) const

private

Private function used for the filtering. It creates 1D separable operators F.

## CreateNDOperator()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::CreateNDOperator | ( | NeighborhoodType & | F,
|  | const std::string & | whichF,
|  | const CoefficientImageSpacingType & | spacing ) const

private

Private function used for the filtering. It creates ND inseparable operators F.

## DilateRigidityImages()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::DilateRigidityImages | ( |  | ) |

private virtual

Internal function to dilate the rigidity images.

## FillRigidityCoefficientImage()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::FillRigidityCoefficientImage | ( | const ParametersType & | parameters | ) | const

Function to fill the RigidityCoefficientImage every iteration.

## FilterSeparable()

template<class TFixedImage, class TScalarType>

CoefficientImagePointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::FilterSeparable | ( | const CoefficientImageType * | ,
|  | const std::vector< NeighborhoodType > & | Operators ) const

private

Private function used for the filtering. It performs 1D separable filtering.

## GetClassName()

template<class TFixedImage, class TScalarType>

virtual const char * itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::TransformPenaltyTerm< TFixedImage, TScalarType >.

Reimplemented in elastix::TransformRigidityPenalty< TElastix >.

## GetDerivative()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetDerivative | ( | const ParametersType & | parameters,
|  | DerivativeType & | derivative ) const

override

The GetDerivative()-method returns the rigid penalty derivative.

## GetLinearityConditionGradientMagnitude()

template<class TFixedImage, class TScalarType>

virtual const MeasureType & itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetLinearityConditionGradientMagnitude | ( |  | ) |

virtual

Get the gradient magnitude of the linearity condition.

## GetLinearityConditionValue()

template<class TFixedImage, class TScalarType>

virtual const MeasureType & itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetLinearityConditionValue | ( |  | ) |

virtual

Get the value of the linearity condition.

## GetLinearityConditionWeight()

template<class TFixedImage, class TScalarType>

virtual ScalarType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetLinearityConditionWeight | ( |  | ) | const

virtual

## GetOrthonormalityConditionGradientMagnitude()

template<class TFixedImage, class TScalarType>

virtual const MeasureType & itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetOrthonormalityConditionGradientMagnitude | ( |  | ) |

virtual

Get the gradient magnitude of the orthonormality condition.

## GetOrthonormalityConditionValue()

template<class TFixedImage, class TScalarType>

virtual const MeasureType & itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetOrthonormalityConditionValue | ( |  | ) |

virtual

Get the value of the orthonormality condition.

## GetOrthonormalityConditionWeight()

template<class TFixedImage, class TScalarType>

virtual ScalarType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetOrthonormalityConditionWeight | ( |  | ) | const

virtual

## GetPropernessConditionGradientMagnitude()

template<class TFixedImage, class TScalarType>

virtual const MeasureType & itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetPropernessConditionGradientMagnitude | ( |  | ) |

virtual

Get the gradient magnitude of the properness condition.

## GetPropernessConditionValue()

template<class TFixedImage, class TScalarType>

virtual const MeasureType & itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetPropernessConditionValue | ( |  | ) |

virtual

Get the value of the properness condition.

## GetPropernessConditionWeight()

template<class TFixedImage, class TScalarType>

virtual ScalarType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetPropernessConditionWeight | ( |  | ) | const

virtual

## GetValue()

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetValue | ( | const ParametersType & | parameters | ) | const

override

The GetValue()-method returns the rigid penalty value.

## GetValueAndDerivative()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::GetValueAndDerivative | ( | const ParametersType & | parameters,
|  | MeasureType & | value,
|  | DerivativeType & | derivative ) const

override

The GetValueAndDerivative()-method returns the rigid penalty value and its derivative.

## Initialize()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::Initialize | ( |  | ) |

override

Initialize the penalty term.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TFixedImage, class TScalarType>

itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::ITK_DISALLOW_COPY_AND_MOVE | ( | TransformRigidityPenaltyTerm< TFixedImage, TScalarType > |  | ) |

## itkStaticConstMacro() [1/3]

template<class TFixedImage, class TScalarType>

itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

Define the dimension.

## itkStaticConstMacro() [2/3]

template<class TFixedImage, class TScalarType>

itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::itkStaticConstMacro | ( | ImageDimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

## itkStaticConstMacro() [3/3]

template<class TFixedImage, class TScalarType>

itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::itkStaticConstMacro | ( | MovingImageDimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

## New()

template<class TFixedImage, class TScalarType>

Pointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<class TFixedImage, class TScalarType>

void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

PrintSelf.

## SetBSplineTransform()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetBSplineTransform | ( | BSplineTransformType * | _arg | ) |

virtual

Set the B-spline transform in this class. This class expects a BSplineTransform! It is not suited for others.

## SetCalculateLinearityCondition()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetCalculateLinearityCondition | ( | bool | _arg | ) |

virtual

Set the calculation of the linearity condition part, even if we don't use it.

## SetCalculateOrthonormalityCondition()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetCalculateOrthonormalityCondition | ( | bool | _arg | ) |

virtual

Set the calculation of the orthonormality condition part, even if we don't use it.

## SetCalculatePropernessCondition()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetCalculatePropernessCondition | ( | bool | _arg | ) |

virtual

Set the calculation of the properness condition part., even if we don't use it.

## SetDilateRigidityImages()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetDilateRigidityImages | ( | bool | _arg | ) |

virtual

Get the value of the total rigidity penalty term. Set if the RigidityImage's are dilated.

## SetDilationRadiusMultiplier()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetDilationRadiusMultiplier | ( | CoordinateRepresentationType | _arg | ) |

virtual

Set the DilationRadiusMultiplier.

## SetFixedRigidityImage()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetFixedRigidityImage | ( | RigidityImageType * | _arg | ) |

virtual

Set the fixed coefficient image.

## SetLinearityConditionWeight()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetLinearityConditionWeight | ( | ScalarType | _arg | ) |

virtual

Set the RigidityImage in this class. Set/Get the weight of the linearity condition part.

## SetMovingRigidityImage()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetMovingRigidityImage | ( | RigidityImageType * | _arg | ) |

virtual

Set the moving coefficient image.

## SetOrthonormalityConditionWeight()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetOrthonormalityConditionWeight | ( | ScalarType | _arg | ) |

virtual

Set/Get the weight of the orthonormality condition part.

## SetPropernessConditionWeight()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetPropernessConditionWeight | ( | ScalarType | _arg | ) |

virtual

Set/Get the weight of the properness condition part.

## SetUseFixedRigidityImage()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetUseFixedRigidityImage | ( | bool | _arg | ) |

virtual

Set to use the FixedRigidityImage or not.

## SetUseLinearityCondition()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetUseLinearityCondition | ( | bool | _arg | ) |

virtual

Set the usage of the linearity condition part.

## SetUseMovingRigidityImage()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetUseMovingRigidityImage | ( | bool | _arg | ) |

virtual

Set to use the MovingRigidityImage or not.

## SetUseOrthonormalityCondition()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetUseOrthonormalityCondition | ( | bool | _arg | ) |

virtual

Set the usage of the orthonormality condition part.

## SetUsePropernessCondition()

template<class TFixedImage, class TScalarType>

virtual void itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::SetUsePropernessCondition | ( | bool | _arg | ) |

virtual

Set the usage of the properness condition part.

## Field Documentation

## m_BSplineTransform

template<class TFixedImage, class TScalarType>

BSplineTransformPointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_BSplineTransform {}

private

Member variables.

Definition at line 320 of file itkTransformRigidityPenaltyTerm.h.

## m_CalculateLinearityCondition

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_CalculateLinearityCondition {}

private

Definition at line 336 of file itkTransformRigidityPenaltyTerm.h.

## m_CalculateOrthonormalityCondition

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_CalculateOrthonormalityCondition {}

private

Definition at line 337 of file itkTransformRigidityPenaltyTerm.h.

## m_CalculatePropernessCondition

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_CalculatePropernessCondition {}

private

Definition at line 338 of file itkTransformRigidityPenaltyTerm.h.

## m_DilateRigidityImages

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_DilateRigidityImages {}

private

Definition at line 342 of file itkTransformRigidityPenaltyTerm.h.

## m_DilationRadiusMultiplier

template<class TFixedImage, class TScalarType>

CoordinateRepresentationType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_DilationRadiusMultiplier {}

private

Rigidity image variables.

Definition at line 341 of file itkTransformRigidityPenaltyTerm.h.

## m_FixedRigidityImage

template<class TFixedImage, class TScalarType>

RigidityImagePointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_FixedRigidityImage {}

private

Definition at line 344 of file itkTransformRigidityPenaltyTerm.h.

## m_FixedRigidityImageDilated

template<class TFixedImage, class TScalarType>

RigidityImagePointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_FixedRigidityImageDilated {}

private

Definition at line 349 of file itkTransformRigidityPenaltyTerm.h.

## m_FixedRigidityImageDilation

template<class TFixedImage, class TScalarType>

std::vector<DilateFilterPointer> itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_FixedRigidityImageDilation {}

private

Definition at line 347 of file itkTransformRigidityPenaltyTerm.h.

## m_LinearityConditionGradientMagnitude

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_LinearityConditionGradientMagnitude {}

mutable private

Definition at line 329 of file itkTransformRigidityPenaltyTerm.h.

## m_LinearityConditionValue

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_LinearityConditionValue {}

mutable private

Definition at line 326 of file itkTransformRigidityPenaltyTerm.h.

## m_LinearityConditionWeight

template<class TFixedImage, class TScalarType>

ScalarType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_LinearityConditionWeight {}

private

Definition at line 321 of file itkTransformRigidityPenaltyTerm.h.

## m_MovingRigidityImage

template<class TFixedImage, class TScalarType>

RigidityImagePointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_MovingRigidityImage {}

private

Definition at line 345 of file itkTransformRigidityPenaltyTerm.h.

## m_MovingRigidityImageDilated

template<class TFixedImage, class TScalarType>

RigidityImagePointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_MovingRigidityImageDilated {}

private

Definition at line 350 of file itkTransformRigidityPenaltyTerm.h.

## m_MovingRigidityImageDilation

template<class TFixedImage, class TScalarType>

std::vector<DilateFilterPointer> itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_MovingRigidityImageDilation {}

private

Definition at line 348 of file itkTransformRigidityPenaltyTerm.h.

## m_OrthonormalityConditionGradientMagnitude

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_OrthonormalityConditionGradientMagnitude {}

mutable private

Definition at line 330 of file itkTransformRigidityPenaltyTerm.h.

## m_OrthonormalityConditionValue

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_OrthonormalityConditionValue {}

mutable private

Definition at line 327 of file itkTransformRigidityPenaltyTerm.h.

## m_OrthonormalityConditionWeight

template<class TFixedImage, class TScalarType>

ScalarType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_OrthonormalityConditionWeight {}

private

Definition at line 322 of file itkTransformRigidityPenaltyTerm.h.

## m_PropernessConditionGradientMagnitude

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_PropernessConditionGradientMagnitude {}

mutable private

Definition at line 331 of file itkTransformRigidityPenaltyTerm.h.

## m_PropernessConditionValue

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_PropernessConditionValue {}

mutable private

Definition at line 328 of file itkTransformRigidityPenaltyTerm.h.

## m_PropernessConditionWeight

template<class TFixedImage, class TScalarType>

ScalarType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_PropernessConditionWeight {}

private

Definition at line 323 of file itkTransformRigidityPenaltyTerm.h.

## m_RigidityCoefficientImage

template<class TFixedImage, class TScalarType>

RigidityImagePointer itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_RigidityCoefficientImage {}

private

Definition at line 346 of file itkTransformRigidityPenaltyTerm.h.

## m_RigidityCoefficientImageIsFilled

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_RigidityCoefficientImageIsFilled {}

mutable private

Definition at line 343 of file itkTransformRigidityPenaltyTerm.h.

## m_RigidityPenaltyTermValue

template<class TFixedImage, class TScalarType>

MeasureType itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_RigidityPenaltyTermValue {}

mutable private

Definition at line 325 of file itkTransformRigidityPenaltyTerm.h.

## m_UseFixedRigidityImage

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_UseFixedRigidityImage {}

private

Definition at line 351 of file itkTransformRigidityPenaltyTerm.h.

## m_UseLinearityCondition

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_UseLinearityCondition {}

private

Definition at line 333 of file itkTransformRigidityPenaltyTerm.h.

## m_UseMovingRigidityImage

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_UseMovingRigidityImage {}

private

Definition at line 352 of file itkTransformRigidityPenaltyTerm.h.

## m_UseOrthonormalityCondition

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_UseOrthonormalityCondition {}

private

Definition at line 334 of file itkTransformRigidityPenaltyTerm.h.

## m_UsePropernessCondition

template<class TFixedImage, class TScalarType>

bool itk::TransformRigidityPenaltyTerm< TFixedImage, TScalarType >::m_UsePropernessCondition {}

private

Definition at line 335 of file itkTransformRigidityPenaltyTerm.h.

Generated on 1768596610 for elastix by 1.15.0 |